// Left sensor
const int trigPin1 = 3; // Trigger output pin (Left sensor)
const int echoPin1 = 4; // Echo input pin (Left sensor)

// Right sensor
const int trigPin2 = 6;  // Trigger output pin (Right sensor) 
const int echoPin2 = 7;  // Echo input pin (Right sensor) 

// Variables used for distance calculation 
long duration;                               
float r;
unsigned long temp=0;
int temp1=0;

long time_taken;
int dist,distL,distR;

// Calculation to get the measurement of the distance in cm
void calculate_distance(int trigger, int echo)
{
digitalWrite(trigger, LOW);
delayMicroseconds(2);
digitalWrite(trigger, HIGH);
delayMicroseconds(10);
digitalWrite(trigger, LOW);

time_taken = pulseIn(echo, HIGH);
dist= time_taken*0.034/2;
if (dist>50)
  dist = 50;
}

void setup() 
{
  Serial.begin(9600);

  // Initialize the trigger and echo pins of both sensors as input and output
  pinMode(trigPin1, OUTPUT);
  pinMode(echoPin1, INPUT);
  pinMode(trigPin2, OUTPUT);
  pinMode(echoPin2, INPUT);   
}

void loop()
{
  // "Next" command
  calculate_distance(trigPin2,echoPin2);
  distR =dist;
  if (distR <= 35 && distR >=15) {
    temp = millis();
    while (millis() <= (temp + 300)) {
      calculate_distance(trigPin1,echoPin1);
      distL =dist;

      calculate_distance(trigPin2,echoPin2);
      distR =dist;
    }
    if (distR > 35 || distR <15)
      Serial.println("next");
   }

   // "Previous" command
   calculate_distance(trigPin1,echoPin1);
   distL =dist;

   if (distL <= 35 && distL >=15) {
    temp = millis();
    while (millis() <= (temp + 300))
    {
      calculate_distance(trigPin1,echoPin1);
      distL =dist;

      calculate_distance(trigPin2,echoPin2);
      distR =dist;
    }

    Serial.println("previous");
    while (distL <= 35 && distL >= 15) {
      calculate_distance(trigPin1,echoPin1);
      distL =dist;

      calculate_distance(trigPin2,echoPin2);
      distR =dist;
    }
   }

  // "Vup" and "Vdown" commands
  calculate_distance(trigPin1,echoPin1);
  distL =dist;

  if (distL>=10 && distL<=20)
  {
    delay(50); //Hand Hold Time
    calculate_distance(trigPin1,echoPin1);
    distL =dist;
    
    if (distL>=10 && distL<=20)
    {
      Serial.println("Left Locked");
      while(distL<=40)
      {
        calculate_distance(trigPin1,echoPin1);
        distL =dist;
        
        if (distL<15) //Hand pushed in 
        {
            Serial.println ("Vup");
            delay (300);}
        if (distL>20) //Hand pulled out
        {
           Serial.println ("Vdown");
           delay (300);}
      }
    }
  }
  
  // "Rewind" and "Forward" commands
  if (distR>=10 && distR<=20)
  {
    delay(50); //Hand Hold Time
    calculate_distance(trigPin2,echoPin2);
    distR =dist;
    
    if (distR>=10 && distR<=20)
    {
      Serial.println("Right Locked");
      while(distR<=40)
      {
        calculate_distance(trigPin2,echoPin2);
        distR =dist;
        if (distR<15 ) //Right hand pushed in
        {
          Serial.println ("Rewind");
          delay (300);}
        if (distR>20) //Right hand pulled out
        {
           Serial.println ("Forward");
           delay (300);}
      }
    }
  }
}
